package com.engine.jclpoc.web;

import com.engine.common.util.ParamUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2024/05/08
 * @version: 1.0
 */
public class PocPerformanceController {

    @GET
    @Path("/getTotalScore")
    @Produces(MediaType.APPLICATION_JSON)
    public Map<String, Object> getTotalScore(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> map = ParamUtil.request2Map(request);
        Map<String, Object> returnMap = new HashMap<>();
        returnMap.put("api_status", true);
        String hdId = Util.null2String(map.get("hdId"));
        String bpr = Util.null2String(map.get("bpr"));
        RecordSet rs = new RecordSet();
        // 查询明细表已完成评价且得分不为空的数据
        rs.executeQuery("select * from uf_360pjhd_dt2 where mainid = ? and bpr = ? and sfpjwc = 1 and df is not null", hdId, bpr);
        int count = 0;
        double sum = 0;
        while (rs.next()) {
            count++;
            sum += rs.getDouble("df");
        }
        if (count > 0 && sum > 0) {
            // 计算并保留两位小数
            BigDecimal dividend = new BigDecimal(sum);
            BigDecimal divisor = new BigDecimal(count);
            BigDecimal result = dividend.divide(divisor, 2, RoundingMode.HALF_UP);
            returnMap.put("totalScore", result);
        } else {
            returnMap.put("totalScore", 0);
        }

        return returnMap;
    }
}
